<?php


namespace OrganizationsManagement\Repository;

use Doctrine\ORM\EntityManager;
use Teknisa\Model\Traits\TQuery;

class StructureType
{
    use TQuery;
    /**
     * @var EntityManager
     */
    private $entityManager;

    /**
     * Classification constructor.
     * @param EntityManager $entityManager
     */
    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    /**
     * @param $orgaznizationId
     * @return array
     */
    public function findStructureType($orgaznizationId): array
    {
        $query = <<<SQL
            SELECT ST.ID, ST.LABEL, ST.CONTROL
              FROM STRUCTURE_TYPE ST
             WHERE ST.ORGANIZATION = :ORGANIZATION
               AND ST.ID IN (SELECT STRUCTURE_TYPE
                              FROM STRUCTURE S
                             WHERE S.STATUS = 'A')
SQL;
        $params = array(
            'ORGANIZATION' => $orgaznizationId
        );
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $query, $params);
    }
}
